﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

namespace Assets
{
	public class Headstone: Tile
	{

		public Headstone(int x, int y, Margaret margie)
			:base(x, y)
		{
			int choice = (int)Math.Floor(UnityEngine.Random.Range(0f, 3.999f));
			//myTexture_headstone = UnityEditor.AssetDatabase.LoadAssetAtPath<Texture2D>("Assets/Images/Gravestones/Gravestones_" + choice + ".png");
			//myTexture_floor = UnityEditor.AssetDatabase.LoadAssetAtPath<Texture2D>("Assets/Images/Grass/Grasstiles_" + choice + ".png");
			myTexture_headstone = Resources.Load<Texture2D>("Images/Gravestones/Gravestones_" + choice);
			myTexture_floor = Resources.Load<Texture2D>("Images/Grass/Grasstiles_" + choice);

			Sprite mySprite_headstone = Sprite.Create(myTexture_headstone, new Rect(0, 0, 64, 64), new Vector2(), 64);
            Sprite mySprite_floor = Sprite.Create(myTexture_floor, new Rect(0, 0, 64, 64), new Vector2(), 64);

            new_sprite_headstone = new GameObject();
            new_sprite_floor = new GameObject();

            new_sprite_headstone.AddComponent<SpriteRenderer>();
            new_sprite_floor.AddComponent<SpriteRenderer>();

            SpriteRenderer ui_renderer_headstone = new_sprite_headstone.GetComponent<SpriteRenderer>();
			ui_renderer_headstone.sortingLayerName = "Background";
            SpriteRenderer ui_renderer_floor = new_sprite_floor.GetComponent<SpriteRenderer>();
			ui_renderer_floor.sortingLayerName = "Background";

			ui_renderer_headstone.sprite = mySprite_headstone;
            ui_renderer_floor.sprite = mySprite_floor;

			new_sprite_floor.transform.position = new Vector3(x-.5f , y-.5f, 0);
            new_sprite_headstone.transform.position = new Vector3(x - .5f, y - .5f, 0);

            Occupied = new Human(x, y, null);
			if(UnityEngine.Random.Range(0f, 1f) > 0.5f)
			{
				HasClue = true;
				ClueKeys.Add(margie.ClueKeys[UnityEngine.Random.Range(0, margie.ClueKeys.Count)]);
			}
			ReadOut = CreateReadout();
		}

		public string CreateReadout()
		{
			string output = "";
			output += GenerateName().ToUpper();//name
			output += "\r\n";
			output += GenerateYears();//years
			output += "\r\n";
			output += epitaphs[UnityEngine.Random.Range(0, epitaphs.Count)];
			return output;
		}
		  
		public void ResetToWinner()
		{
			WinnerStone = true;
			ReadOut = "1930-1996\r\nBenjamin Johnson\r\nCaring Father and Loving Husband";
		}

		public string ReadOut = "1900-1920\r\nBob Jones\r\nLoved By all";

        GameObject new_sprite_headstone;
        GameObject new_sprite_floor;
        public Texture2D myTexture_headstone;
        public Texture2D myTexture_floor;
		public bool WinnerStone;

		private string GenerateYears()
		{
			string output = "";
			int year1 = UnityEngine.Random.Range(1900, 1950);
			int year2 = year1 + UnityEngine.Random.Range(10, 60);
			output += year1;
			output += "-";
			output += year2;
			return output;
		}

		private string GenerateName()
		{
			string output = "";

			float gender = UnityEngine.Random.Range(0f, 1f);
			if (gender > 0.5)
			{
				output += ManFirst[UnityEngine.Random.Range(0, ManFirst.Count)];
			}
			else
			{
				output += LadyNames[UnityEngine.Random.Range(0, LadyNames.Count)];
			}
			output += " ";
			output += surnames[UnityEngine.Random.Range(0, surnames.Count)];
			return output;
		}

		#region names

		public List<string> surnames = new List<string> { "SMITH",
"JOHNSON",
"WILLIAMS",
"JONES",
"BROWN",
"DAVIS",
"MILLER",
"WILSON",
"MOORE",
"TAYLOR",
"ANDERSON",
"THOMAS",
"JACKSON",
"WHITE",
"HARRIS",
"MARTIN",
"THOMPSON",
"GARCIA",
"MARTINEZ",
"ROBINSON",
"CLARK",
"RODRIGUEZ",
"LEWIS",
"LEE",
"WALKER",
"HALL",
"ALLEN",
"YOUNG",
"HERNANDEZ",
"KING",
"WRIGHT",
"LOPEZ",
"HILL",
"SCOTT",
"GREEN",
"ADAMS",
"BAKER",
"GONZALEZ",
"NELSON",
"CARTER",
"MITCHELL",
"PEREZ",
"ROBERTS",
"TURNER",
"PHILLIPS",
"CAMPBELL",
"PARKER",
"EVANS",
"EDWARDS",
"COLLINS",
"STEWART",
"SANCHEZ",
"MORRIS",
"ROGERS",
"REED",
"COOK",
"MORGAN",
"BELL",
"MURPHY",
"BAILEY",
"RIVERA",
"COOPER",
"RICHARDSON",
"COX",
"HOWARD",
"WARD",
"TORRES",
"PETERSON",
"GRAY",
"RAMIREZ",
"JAMES",
"WATSON",
"BROOKS",
"KELLY",
"SANDERS",
"PRICE",
"BENNETT",
"WOOD",
"BARNES",
"ROSS",
"HENDERSON",
"COLEMAN",
"JENKINS",
"PERRY",
"POWELL",
"LONG",
"PATTERSON",
"HUGHES",
"FLORES",
"WASHINGTON",
"BUTLER",
"SIMMONS",
"FOSTER",
"GONZALES",
"BRYANT",
"ALEXANDER",
"RUSSELL",
"GRIFFIN",
"DIAZ",
"HAYES",
"MYERS",
"FORD",
"HAMILTON",
"GRAHAM",
"SULLIVAN",
"WALLACE",
"WOODS",
"COLE",
"WEST",
"JORDAN",
"OWENS",
"REYNOLDS",
"FISHER",
"ELLIS",
"HARRISON",
"GIBSON",
"MCDONALD",
"CRUZ",
"MARSHALL",
"ORTIZ",
"GOMEZ",
"MURRAY",
"FREEMAN",
"WELLS",
"WEBB",
"SIMPSON",
"STEVENS",
"TUCKER",
"PORTER",
"HUNTER",
"HICKS",
"CRAWFORD",
"HENRY",
"BOYD",
"MASON",
"MORALES",
"KENNEDY",
"WARREN",
"DIXON",
"RAMOS",
"REYES",
"BURNS",
"GORDON",
"SHAW",
"HOLMES",
"RICE",
"ROBERTSON",
"HUNT",
"BLACK",
"DANIELS",
"PALMER",
"MILLS",
"NICHOLS",
"GRANT",
"KNIGHT",
"FERGUSON",
"ROSE",
"STONE",
"HAWKINS",
"DUNN",
"PERKINS",
"HUDSON",
"SPENCER",
"GARDNER",
"STEPHENS",
"PAYNE",
"PIERCE",
"BERRY",
"MATTHEWS",
"ARNOLD",
"WAGNER",
"WILLIS",
"RAY",
"WATKINS",
"OLSON",
"CARROLL",
"DUNCAN",
"SNYDER",
"HART",
"CUNNINGHAM",
"BRADLEY",
"LANE",
"ANDREWS",
"RUIZ",
"HARPER",
"FOX",
"RILEY",
"ARMSTRONG",
"CARPENTER",
"WEAVER",
"GREENE",
"LAWRENCE",
"ELLIOTT",
"CHAVEZ",
"SIMS",
"AUSTIN",
"PETERS",
"KELLEY",
"FRANKLIN",
"LAWSON" };

		public List<string> LadyNames = new List<string> {
			"Mary",
"Helen",
"Margaret",
"Anna",
"Ruth",
"Elizabeth",
"Dorothy",
"Marie",
"Florence",
"Mildred",
"Alice",
"Ethel",
"Lillian",
"Gladys",
"Edna",
"Frances",
"Rose",
"Annie",
"Grace",
"Bertha",
"Emma",
"Bessie",
"Clara",
"Hazel",
"Irene",
"Gertrude",
"Louise",
"Catherine",
"Martha",
"Mabel",
"Pearl",
"Edith",
"Esther",
"Minnie",
"Myrtle",
"Ida",
"Josephine",
"Evelyn",
"Elsie",
"Eva",
"Thelma",
"Ruby",
"Agnes",
"Sarah",
"Viola",
"Nellie",
"Beatrice",
"Julia",
"Laura",
"Lillie",
"Lucille",
"Ella",
"Virginia",
"Mattie",
"Pauline",
"Carrie",
"Alma",
"Jessie",
"Mae",
"Lena",
"Willie",
"Katherine",
"Blanche",
"Hattie",
"Marion",
"Lucy",
"Stella",
"Mamie",
"Vera",
"Cora",
"Fannie",
"Eleanor",
"Bernice",
"Jennie",
"Ann",
"Leona",
"Beulah",
"Lula",
"Rosa",
"Ada",
"Ellen",
"Kathryn",
"Maggie",
"Doris",
"Dora",
"Betty",
"Marguerite",
"Violet",
"Lois",
"Daisy",
"Anne",
"Sadie",
"Susie",
"Nora",
"Georgia",
"Maude",
"Marjorie",
"Opal",
"Hilda",
"Velma",
"Emily",
"Theresa",
"Charlotte",
"Inez",
"Olive",
"Flora",
"Della",
"Lola",
"Jean",
"Effie",
"Nancy",
"Nettie",
"Sylvia",
"May",
"Lottie",
"Alberta",
"Eunice",
"Sallie",
"Katie",
"Genevieve",
"Estelle",
"Lydia",
"Loretta",
"Mable",
"Goldie",
"Eula",
"Rosie",
"Lizzie",
"Vivian",
"Verna",
"Ollie",
"Harriet",
"Lucile",
"Addie",
"Marian",
"Henrietta",
"Jane",
"Lela",
"Essie",
"Caroline",
"Ora",
"Iva",
"Sara",
"Maria",
"Madeline",
"Rebecca",
"Wilma",
"Etta",
"Barbara",
"Rachel",
"Kathleen",
"Irma",
"Christine",
"Geneva",
"Sophie",
"Juanita",
"Nina",
"Naomi",
"Victoria",
"Amelia",
"Erma",
"Mollie",
"Susan",
"Flossie",
"Ola",
"Nannie",
"Norma",
"Sally",
"Olga",
"Alta",
"Estella",
"Celia",
"Freda",
"Isabel",
"Amanda",
"Frieda",
"Luella",
"Matilda",
"Janie",
"Fern",
"Cecelia",
"Audrey",
"Winifred",
"Elva",
"Ina",
"Adeline",
"Leola",
"Hannah",
"Geraldine",
"Amy",
"Allie",
"Miriam",
"Isabelle",
"Bonnie",
"Virgie",
"Sophia",
"Cleo",
"Jeanette",
"Nell",
"Eliza" };

		public List<string> ManFirst = new List<string> {
			"John",
"William",
"James",
"George",
"Charles",
"Robert",
"Joseph",
"Frank",
"Edward",
"Thomas",
"Henry",
"Walter",
"Harry",
"Willie",
"Arthur",
"Albert",
"Clarence",
"Fred",
"Harold",
"Paul",
"Raymond",
"Richard",
"Roy",
"Joe",
"Louis",
"Carl",
"Ralph",
"Earl",
"Jack",
"Ernest",
"David",
"Samuel",
"Howard",
"Charlie",
"Francis",
"Herbert",
"Lawrence",
"Theodore",
"Alfred",
"Andrew",
"Elmer",
"Sam",
"Eugene",
"Leo",
"Michael",
"Lee",
"Herman",
"Anthony",
"Daniel",
"Leonard",
"Floyd",
"Donald",
"Kenneth",
"Jesse",
"Russell",
"Clyde",
"Oscar",
"Peter",
"Lester",
"Leroy",
"Ray",
"Stanley",
"Clifford",
"Lewis",
"Benjamin",
"Edwin",
"Frederick",
"Chester",
"Claude",
"Eddie",
"Cecil",
"Lloyd",
"Jessie",
"Martin",
"Bernard",
"Tom",
"Will",
"Norman",
"Edgar",
"Harvey",
"Ben",
"Homer",
"Luther",
"Leon",
"Melvin",
"Philip",
"Johnnie",
"Jim",
"Milton",
"Everett",
"Allen",
"Leslie",
"Alvin",
"Victor",
"Marvin",
"Stephen",
"Alexander",
"Jacob",
"Hugh",
"Patrick",
"Virgil",
"Horace",
"Glenn",
"Oliver",
"Morris",
"Vernon",
"Archie",
"Julius",
"Gerald",
"Maurice",
"Sidney",
"Marion",
"Otis",
"Vincent",
"Guy",
"Earnest",
"Wilbur",
"Gilbert",
"Willard",
"Ed",
"Roosevelt",
"Hubert",
"Manuel",
"Warren",
"Otto",
"Alex",
"Ira",
"Wesley",
"Curtis",
"Wallace",
"Lonnie",
"Gordon",
"Isaac",
"Jerry",
"Charley",
"Jose",
"Nathan",
"Max",
"Mack",
"Rufus",
"Arnold",
"Irving",
"Percy",
"Bill",
"Dan",
"Willis",
"Bennie",
"Jimmie",
"Orville",
"Sylvester",
"Rudolph",
"Glen",
"Nicholas",
"Dewey",
"Emil",
"Roland",
"Steve",
"Calvin",
"Mike",
"Johnie",
"Bert",
"August",
"Clifton",
"Franklin",
"Matthew",
"Emmett",
"Phillip",
"Wayne",
"Edmund",
"Abraham",
"Nathaniel",
"Marshall",
"Dave",
"Elbert",
"Clinton",
"Felix",
"Alton",
"Ellis",
"Nelson",
"Amos",
"Clayton",
"Aaron",
"Perry",
"Adam",
"Tony",
"Irvin",
"Jake",
"Dennis",
"Jerome",
"Mark",
"Cornelius",
"Ollie",
"Douglas",
"Pete",
"Ted",
"Adolph",
"Roger",
"Jay",
"Roscoe",
"Juan" };

		#endregion

		#region epitaphs

		public List<string> epitaphs  = new List<string> {
		"Earth has no sorrow that heaven can not heal",
"Gone, but not forgotten",
"In Loving Memory",
"To live in the hearts of those we love is never to die",
"Entered into rest",
"Until we meet again",
"I shall but love thee better after death",
"Forever in our hearts",
"Always in our hearts",
"Rest in Peace",
"Too well loved to ever be forgotten",
"Home with God, which is far better",
"The song is ended, but the melody lingers on",
"Rest in thine, sweet memory ours",
"Sweetly sleeping",
"Loving memories last forever",
"Hasten, oh blessed hour or reunion",
"Step softly, a dream lies buried here",
"Your love will light my way",
"Your memory will ever be with me",
"What we keep in memory is ours unchanged forever",
"Death is only a shadow across the path to heaven",
"In the morning we will remember them",
"Through the mercy of God rest in peace",
"He gave thee, He took thee,and He will restore thee",
"Death is the golden key that opens the palace of Eternity.",
"There is a sweet job that comes to us through sorrow.",
"Earth hath no sorrow that heaven cannot heal.",
"...There hath pass'd away a glory from the earth.",
"The cross leads generations on.",
"Death's but a path to be trod if man would ever pass to God.",
"Life's a voyage that's homeward bound.",
"He hath awakened from the dream of life.",
"Beyond is the infinite morning of a day without tomorrow.",
"Where He leads me I can safely go.",
"Whither thou goest, I will go.",
"Faith builds a bridge across the gulf of death.",
"Until the day break, and the shadows flee away.",
"'Tis not the whole of life to live, nor all of death to die.",
"Where there is sorrow there is holy ground.",
"Now twilight lets her curtain down and pins it with a star.",
"Earth has no sorrow that heaven cannot heal.",
"Where there is much light, the shadows are deepest.",
"In Loving Memory",
"Rest in Peace",
"Forever in Our Hearts",
"Each Soul Leaves a Legacy of Love",
"Lost Now but Loved Forever",
"Time Passes, Love Remains",
"We Will Love You Always",
"An Inspiration to All",
"Peace Perfect Peace",
"Sacred are the Memories",
"Loved from Here to Eternity",
"Fondly Loved and Deeply Mourned",
"Ever Kind and True",
"A Love, True And Constant",
"A Sharing, Caring Person",
"A Special Kind Of Love",
"Grace And Dignity",
"Always In Our Hearts",
"An Inspiration To All Of Us",
"An Unforgettable Person",
"Asked For So Little But Gave So Very Much",
"Brave In Spirit, Strong In Love",
"Constant Of Faith, Generous By Heart",
"Devoted In Love",
"Everybody’s Best Friend",
"Faith, Hope And Courage",
"Faithful Forever",
"Forever Grateful And Faithful",
"Forever In Our Hearts",
"Forever Missed",
"Gone But Never Forgotten",
"In God’s Care",
"In Loving Memory",
"In Memoriam",
"In One Of The Stars I Shall Be Living",
"Life If Not Forever, Love Is",
"Love Is A Light That Never Dims",
"Mourn Not My Death, But Celebrate My Life",
"My Lifetime Companion",
"One Of A Kind",
"Our Little Angel",
"Our Love Is Eternal",
"Rest In Peace",
"Strong In Love, Brave In Spirit",
"The Best Is Yet To Come",
"Together Forever",
"Until We Meet Again",
"We Miss You",
"We Remember How You Loved Us",
"We’ll Be Together Again",
"What We Keep In Memory, Is Ours Forever",
"Wonderful Was Your Love For Us",
"Your Light Will Shine Forever",
"Love Never Ends",
"They Gave Their Today for Our Tomorrow",
"Loving Memories Last Forever",
"Earth has no Sorrow that Heaven Cannot Heal",
"To Live in the Hearts of Others is not to Die",
"Forever Young, Forever in our Hearts",
"Precious are the Memories" };

		#endregion

	}
}
