﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

namespace Assets
{
	public class Human
	{

		public Human(int x, int y, Level model)
		{
			_x = x;
			_y = y;
			_oldX = x;
			_oldY = y;
			RemainingMove = -1;
			myLevel = model;
		}
		
		public void ShowChange()
		{
			if (catchMove)
			{
				float distCovered = RemainingMove;
				startTime -= RemainingMove * 1.5f;
				Vector3 oldLoc = new_sprite.transform.position;
				new_sprite.transform.position = Vector3.Lerp(new Vector3(_oldX, _oldY, 0), new Vector3(X, Y, 0), distCovered);
				catchMove = false;
				RemainingMove = 0;
			}
			else {
				float distCovered = (Time.time - startTime) * 1.5f;
				Vector3 oldLoc = new_sprite.transform.position;
				new_sprite.transform.position = Vector3.Lerp(new Vector3(_oldX, _oldY, 0), new Vector3(X, Y, 0), distCovered);
				if (distCovered >= 1)
				{
					lerping = false;
					RemainingMove = distCovered - 1;
					if ((Input.GetKeyDown(KeyCode.RightArrow)) || (Input.GetKey(KeyCode.RightArrow)))
					{
						if (!lerping)
						{
							myLevel.MovePerson(this, Direction.East);
						}
					}
					if ((Input.GetKeyDown(KeyCode.LeftArrow)) || (Input.GetKey(KeyCode.LeftArrow)))
					{
						if(!lerping)
						{
							//Continue Left
							myLevel.MovePerson(this, Direction.West);
						}
					}
					if ((Input.GetKeyDown(KeyCode.UpArrow)) || (Input.GetKey(KeyCode.UpArrow)))
					{
						if (!lerping)
						{
							//Continue Up
							myLevel.MovePerson(this, Direction.North);
						}
					}
					if ((Input.GetKeyDown(KeyCode.DownArrow)) || (Input.GetKey(KeyCode.DownArrow)))
					{
						if (!lerping)
						{
							//Continue Down
							myLevel.MovePerson(this, Direction.South);
						}
					}
				}
			}
			Animator anim = new_sprite.GetComponent<Animator>();
			anim.SetBool("Lerping", lerping);
			anim.SetInteger("Direction", moveDirection);
		}

		public void Face(int Direction)
		{
			moveDirection = Direction;
			Animator anim = new_sprite.GetComponent<Animator>();
			anim.SetInteger("Direction", moveDirection);
		}
		public GameObject new_sprite;
		public Texture2D myTexture;
		private int _x;
		private int _y;
		private int _oldX;
		private int _oldY;
		public bool lerping;
		public float RemainingMove;
		public bool catchMove;
		private float startTime; 
		public int X {
			get
			{
				return _x;
			}
			set
			{
				if (_x != value)
				{
					_oldX = _x;
					_oldY = _y;
					_x = value;
					if(_oldX < _x)
					{
						moveDirection = Direction.East;
					}
					else
					{
						moveDirection = Direction.West;
					}
					lerping = true;
					startTime = Time.time;
					ShowChange();
				}
			}
		}
		public int Y
		{
			get
			{
				return _y;
			}
			set
			{
				if (_y != value)
				{
					_oldX = _x;
					_oldY = _y;
					_y = value;
					if(_oldY< _y)
					{
						moveDirection = Direction.North;
					}
					else
					{
						moveDirection = Direction.South;
					}
					lerping = true;
					startTime = Time.time;
					ShowChange();
				}
			}
		}

		virtual public string InteractWith(Tile target)
		{
			return "Interacted with {" + target.X + "," + target.Y + "}";
		}

		public int moveDirection = Direction.South;
		private Level myLevel;

	}
}
