﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

namespace Assets
{
	public class Level
	{

		public AudioSource bumpaudio;
		public Level()
		{
			headStones = new List<Headstone>();
			margaret = new Margaret(5, 5, this);
			Tiles = new List<List<Tile>>();
			for(int i = 0; i< LevelWidth; i++) //i = width
			{
				Tiles.Add(new List<Tile>());
				for (int j = 0; j < LevelHeight; j++) //j == height
				{
                    if ((j <5) || (j > LevelHeight -5) || (i < 5) || (i > LevelWidth-5))
                    {
                        Tiles[i].Add(new Hedge(i, j));
                    }
					else if ((i > 5 && i < LevelWidth - 5) && (j % 2 != 1))  //even rows
					{
						Headstone newHead = new Headstone(i, j, margaret);
						Tiles[i].Add(newHead);
						headStones.Add(newHead);
                    }
					else {
						Tiles[i].Add(new Floor(i, j));
					}
				}
			}
			Tiles[0][0].Occupied = margaret;
			//headStones[headStones.Count - 1].WinnerStone = true;
			headStones[UnityEngine.Random.Range(0, headStones.Count)].WinnerStone = true;
		}

		public void MovePerson(Human target, int direction)
		{
			if (direction == 1)
			{
				if (target.Y + 1 < LevelHeight) {
					if (Tiles[target.X][target.Y + 1].Occupied == null)
					{
						Tiles[target.X][target.Y].Occupied = null;
						target.Y++;
						Tiles[target.X][target.Y].Occupied = target;
					}
					else
					{
						if (!bumpaudio.isPlaying)
							bumpaudio.Play();
						target.Face(direction);
					}
				}
				else
				{
					if (!bumpaudio.isPlaying)
						bumpaudio.Play();
					target.Face(direction);
				}
			}
			if(direction == 2)
			{
				if (target.X + 1 < LevelWidth)
				{
					if (Tiles[target.X+1][target.Y].Occupied == null)
					{
						Tiles[target.X][target.Y].Occupied = null;
						target.X++;
						Tiles[target.X][target.Y].Occupied = target;
					}
					else
					{
						if (!bumpaudio.isPlaying)
							bumpaudio.Play();
						target.Face(direction);
					}
				}
				else
				{
					if (!bumpaudio.isPlaying)
						bumpaudio.Play();
					target.Face(direction);
				}
			}
			if(direction == 3)
			{
				if (target.Y > 0)
				{
					if (Tiles[target.X][target.Y - 1].Occupied == null)
					{
						Tiles[target.X][target.Y].Occupied = null;
						target.Y--;
						Tiles[target.X][target.Y].Occupied = target;
					}
					else
					{
						if (!bumpaudio.isPlaying)
							bumpaudio.Play();
						target.Face(direction);
					}
				}
				else
				{
					if (!bumpaudio.isPlaying)
						bumpaudio.Play();
					target.Face(direction);
				}
			}
			if(direction == 4)
			{
				if (target.X > 0)
				{
					if (Tiles[target.X - 1][target.Y].Occupied == null)
					{
						Tiles[target.X][target.Y].Occupied = null;
						target.X--;
						Tiles[target.X][target.Y].Occupied = target;
					}
					else
					{
						if (!bumpaudio.isPlaying)
							bumpaudio.Play();
						target.Face(direction);
					}
				}
				else
				{
					if (!bumpaudio.isPlaying)
						bumpaudio.Play();
					target.Face(direction);
				}
			}
		}

		public void Interact()
		{
			if (margaret.moveDirection == Direction.North)
			{
				if (margaret.Y < LevelHeight - 1)
				{
					ShowPopOver(margaret.InteractWith(Tiles[margaret.X][margaret.Y + 1]));
				}
			}
			else if (margaret.moveDirection == Direction.South)
			{
				if (margaret.Y > 0)
				{
					ShowPopOver(margaret.InteractWith(Tiles[margaret.X][margaret.Y - 1]));
				}
			}
			else if (margaret.moveDirection == Direction.East)
			{
				if (margaret.X < LevelWidth - 1)
				{
					ShowPopOver(margaret.InteractWith(Tiles[margaret.X + 1][margaret.Y]));
				}
			}
			else if (margaret.moveDirection == Direction.West)
			{
				if (margaret.X > 0)
				{
					ShowPopOver(margaret.InteractWith(Tiles[margaret.X - 1][margaret.Y]));
				}
			}
		}


		public void ShowPopOver(string text)
		{
			if (string.IsNullOrEmpty(text))
			{
				return;
			}
			Debug.Log(text);
			currentPopover = new Popover(text);
		}

		public Popover currentPopover;
		public List<List<Tile>> Tiles;
		public Margaret margaret;
		public int LevelWidth = 22;
		public int LevelHeight = 23;
		public List<Headstone> headStones;
	}
}
