﻿using UnityEngine;
using System.Collections;
using Assets;


public class MainGame : MonoBehaviour {

    public AudioSource audio;
	public AudioSource bumpaudio_main;
	public bool isMuted = false;


	// Use this for initialization
	void Start ()
	{
		GameObject cam = GameObject.Find("Main Camera");
		cam.transform.position += new Vector3(8, 8, 0);
		myLevel = new Level();
		myLevel.bumpaudio = bumpaudio_main;
	}

	// Update is called once per frame
	void Update()
	{
		if (Input.GetKeyDown(KeyCode.Escape))
		{
			if (QueuedQuit)
			{
				if (myLevel.currentPopover.Dismiss())
				{
					Application.LoadLevel(0);
				}
			}
			else {
				QueuedQuit = true;
				if (myLevel.currentPopover != null)
				{
					if (!myLevel.currentPopover.Dismiss())
					{
						myLevel.currentPopover.Dismiss();
					}
					myLevel.ShowPopOver("Benjamin, I'm msorry I couldn't make it to your grave today...  Believe me, I tried my best.");
				}
			}
		}
		else if (myLevel.margaret.flowerDecay > 6 && !QueuedQuit && !myLevel.margaret.FoundBenny)
		{
			QueuedQuit = true;
			if (myLevel.currentPopover != null)
			{
				if (!myLevel.currentPopover.Dismiss())
				{
					myLevel.currentPopover.Dismiss();
				}
				myLevel.ShowPopOver("Benjamin, I'm sorry I couldn't make it to your grave today...  Believe me, I tried my best.");
			}
		}
		else if (myLevel.margaret.FoundBenny && !QueuedWin)
		{
			QueuedWin = true;
			if (myLevel.currentPopover != null)
			{
				if (!myLevel.currentPopover.Dismiss())
				{
					myLevel.currentPopover.Dismiss();
				}
				myLevel.ShowPopOver("Benjamin!  I found You!  Happy Birthday, my love.");
			}
			else {
				myLevel.ShowPopOver("Benjamin!  I found You!  Happy Birthday, my love.");
			}
		}
		else if (Input.GetKeyDown(KeyCode.M))
		{
			isMuted = !isMuted;
			AudioListener.pause = isMuted;
		}
		else if (myLevel.currentPopover == null)
		{
			if (!myLevel.margaret.lerping)
			{
				if ((Input.GetKeyDown(KeyCode.RightArrow)) || (Input.GetKey(KeyCode.RightArrow)))
				{
					if (!audio.isPlaying)
						audio.Play();
					if (!myLevel.margaret.lerping)
					{
						myLevel.MovePerson(myLevel.margaret, Direction.East);
					}
					else
					{
						myLevel.margaret.Face(Direction.East);
					}
				}
				if ((Input.GetKeyDown(KeyCode.LeftArrow)) || (Input.GetKey(KeyCode.LeftArrow)))
				{
					if (!audio.isPlaying)
						audio.Play();
					if (!myLevel.margaret.lerping)
					{
						myLevel.MovePerson(myLevel.margaret, Direction.West);
					}
					else
					{
						myLevel.margaret.Face(Direction.West);
					}
				}
				if ((Input.GetKeyDown(KeyCode.UpArrow)) || (Input.GetKey(KeyCode.UpArrow)))
				{
					if (!audio.isPlaying)
						audio.Play();
					if (!myLevel.margaret.lerping)
					{
						myLevel.MovePerson(myLevel.margaret, Direction.North);
					}
					else
					{
						myLevel.margaret.Face(Direction.North);
					}
				}
				if ((Input.GetKeyDown(KeyCode.DownArrow)) || (Input.GetKey(KeyCode.DownArrow)))
				{
					if (!audio.isPlaying)
						audio.Play();
					if (!myLevel.margaret.lerping)
					{
						myLevel.MovePerson(myLevel.margaret, Direction.South);
					}
					else
					{
						myLevel.margaret.Face(Direction.South);
					}
				}
				if ((Input.GetKeyDown(KeyCode.Space)))
				{
					myLevel.Interact();
				}
			}
			else
			{
				if (!audio.isPlaying)
					audio.Play();
				myLevel.margaret.ShowChange();
			}
		}
		else
		{
			if ((Input.GetKeyDown(KeyCode.Space)))
			{
				if (myLevel.currentPopover.Dismiss())
				{
					if (QueuedQuit || QueuedWin)
					{
						Application.LoadLevel(0);
					}
					else {
						myLevel.currentPopover = null;
						if (myLevel.margaret.QueuedClue != null)
						{
							myLevel.ShowPopOver(myLevel.margaret.ShowClue(myLevel.margaret.QueuedClue));
						}
					}
				}
			}
			else
			{
				myLevel.currentPopover.Continue();
			}
		}
		CenterCamera();
	}

	private void CenterCamera()
	{
		GameObject marg = myLevel.margaret.new_sprite;
		GameObject cam = GameObject.Find("Main Camera");
		float xDiff = marg.transform.position.x - cam.transform.position.x;
		float yDiff = marg.transform.position.y - cam.transform.position.y;
		float xShift = 0;
		float yShift = 0;
		//Debug.Log("xDiff: " + xDiff + " and yDiff: " + yDiff);
		if (Mathf.Abs(xDiff) > 3)
		{
			xShift = Mathf.Abs(xDiff) - 3;
			if (marg.transform.position.x < cam.transform.position.x)
			{
				xShift *= -1;
			}
		}
		if (Mathf.Abs(yDiff) > 3)
		{
			yShift = Mathf.Abs(yDiff) - 3;
			if (marg.transform.position.y < cam.transform.position.y)
			{
				yShift *= -1;
			}
		}
		cam.transform.position += new Vector3(xShift, yShift, 0);
		myLevel.margaret.myFlowers.new_sprite.transform.position = cam.transform.position - new Vector3(5, 4.5f, cam.transform.position.z);
	}
	

    void onGUI()
    {
        
    }
	public Level myLevel;
	public bool QueuedQuit;
	public bool QueuedWin;
}
