﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

namespace Assets
{
	public class Margaret: Human
	{

		public Margaret(int x, int y, Level model):base(x, y, model)
		{
			//myTexture = UnityEditor.AssetDatabase.LoadAssetAtPath<Texture2D>("Assets/Images/Margaret64.png");
			myTexture = Resources.Load<Texture2D>("Images/Margaret64");
			Sprite mySprite = Sprite.Create(myTexture, new Rect(0, 0, 64, 64), new Vector2(), 64);
			new_sprite = new GameObject();
			new_sprite.AddComponent<SpriteRenderer>();
			SpriteRenderer ui_renderer = new_sprite.GetComponent<SpriteRenderer>();
			ui_renderer.sortingLayerName = "Characters";
			ui_renderer.sprite = mySprite;
			new_sprite.transform.position = new Vector3(x, y, 0);
			Animator anim = new_sprite.AddComponent<Animator>();
			//anim.runtimeAnimatorController = UnityEditor.AssetDatabase.LoadAssetAtPath<RuntimeAnimatorController>("Assets/Images/margaret_0.controller");
			anim.runtimeAnimatorController = Resources.Load<RuntimeAnimatorController>("Images/margaret_0");
			ClueTable = new Dictionary<string, string>();
			ClueFlags = new Dictionary<string, bool>();
			ClueKeys = new List<string>();
			myFlowers = new Flowers(this.flowerDecay);
			PopulateClues();
		}

		private void PopulateClues()
		{
			AddClue("MeetDate", "1954 was a good year.  We met for the first time.");
			AddClue("Sgt", "I think Benjamin was a Seargant while he served.  Such a proud man.");
			AddClue("Father", "Benjamin and I had a son, little Benjamin Junior.");
			AddClue("Division", "I wish I could remember Benjamin's unit.  It woudl help me narrow this down.");
			AddClue("Attitude", "Benjamin always had a bit of a temper.  He got into scraps at bars.");
			AddClue("Baby", "Not long after we married, God blessed us with a baby boy.");
			AddClue("Cried", "Benjamin stayed home from work on our baby's first day of school.  He cried that day.");
			AddClue("Scouts", "Benjamin joined the scouts with our son.  They loved to go camping.");
			AddClue("sonDeath", "Benjamin was never the same after our son passed.");
			AddClue("blame", "I think Benjamin blamed himself for what happened to our boy.");
			AddClue("together", "We stayed together without our son, but it was hard.");
			AddClue("love", "Even through all the tough times, we never stopped loving each other.");
			AddClue("Cancer", "Once Benjamin was diagnosed, it brought us together again.");
			AddClue("repro", "With the end growing nearer, Benjamin and I cherished our final months.");
			AddClue("decline", "Once Benjamin got really bad, I had to take care of him.");
			AddClue("death", "Benjamin's passing was almost a blessing.  He didn't want to be seen like that.");
			AddClue("Concern", "I wonder if I'll ever find his grave.  Its so hard to remember...");
			AddClue("memory", "My memory may not be what it once was, but I'm sure Benjamin is around here somewhere...");
			AddClue("legs", "I just wish I could walk a little faster... The flowers are wilting.");
			AddClue("ritual", "I'm coming, Benjamin.  Just like every year.");
			AddClue("frustration", "Why don't I remember his grave?  Its the one part of him left on earth...");
			AddClue("fear", "What if I can never find his grave?");
			AddClue("confusion", "This has to be the right graveyard, right?  I get so confused sometimes...");
			AddClue("future", "What if I get sick like Benjamin?  I don't have anyone to help me...");
			AddClue("Hurry", "I'm not sure how much longer I can keep wandering.   I need to find his grave soon.");
			AddClue("dancing", "When Benjamin really let loose, it was a thing of beauty.  He loved to dance.");
			AddClue("shopping", "Benjamin was always difficult to shop for.  But I suppose most men are.");
			AddClue("cooking", "Benjamin's mother taught me to cook his favorite - chicken pot pie, just like she did.");
			AddClue("work", "Even after a full day of work, Benjamin always found time for our son.");
			AddClue("home", "Benjamin, got put in a home this year...  I miss OUR home.");
			AddClue("harder", "Everything had gotten harder lately, its so hard being alone.");
			AddClue("alone", "Why did you two have to leave me?  I've got no one left...");
			AddClue("scholarly", "Our son was so smart.  He was top 10% of his class.");
			AddClue("troublemaker", "Even if our son was smart, he still got into trouble, just like his father.");
		}

		private void AddClue(string key, string message)
		{
			ClueTable.Add(key, message);
			ClueFlags.Add(key, false);
			ClueKeys.Add(key);
		}
		
		// Update is called once per frame
		void Update()
		{
			new_sprite.transform.position += new Vector3(0.5f, 0, 0);
		}

		public override string InteractWith(Tile target)
		{
			if (target is Headstone)
			{
				if((target as Headstone).WinnerStone)
				{
					FoundBenny = true;
				}
				TotalSearches++;
				flowerDecay = TotalSearches / 5;
				if (target.HasClue)
				{
					for (int i = 0; i < target.ClueKeys.Count; i++)
					{
						if (!ClueFlags[target.ClueKeys[i]])
						{
							Debug.Log("Queued a clue!");
							QueuedClue = (target.ClueKeys[i]);
							break;
						}
					}
				}
				return (target as Headstone).ReadOut;
			}
			else
			{
				return "";
			}
		}

		public string ShowClue(string key)
		{
			QueuedClue = null;
			ClueFlags[key] = true;
			return ClueTable[key];
		}

		public string QueuedClue;
		public Dictionary<string, string> ClueTable;
		public Dictionary<string, bool> ClueFlags;
		public List<string> ClueKeys;
		public bool FoundBenny;
		public Flowers myFlowers;
		public int flowerDecay
		{
			get
			{
				return _flowerDecay;
			}
			set
			{
				_flowerDecay = value;
				myFlowers.UpdateState(value);
			}
		}

		private int _flowerDecay;
		public int TotalSearches;

	}
}
