﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

namespace Assets
{
	public class Popover
	{
		public Popover(string text)
		{

            GameObject cam = GameObject.Find("Main Camera");

            new_text = new GameObject();
			TextMesh myMesh = new_text.AddComponent<TextMesh>();
			//myMesh.font = UnityEditor.AssetDatabase.LoadAssetAtPath<Font>("Assets/PressStart2P.ttf");
			myMesh.font = Resources.Load<Font>("PressStart2P");
			MeshRenderer meshRenderer = new_text.GetComponent<MeshRenderer>();
			//meshRenderer.material = UnityEditor.AssetDatabase.LoadAssetAtPath<Material>("Assets/PressStart2P.ttf");
			meshRenderer.material = Resources.Load<Material>("PressStart2P");
			myMesh.fontSize = 30;
			myMesh.characterSize = 0.1f;
			//myMesh.text = text;
			SetText(myMesh, meshRenderer, text);
			Debug.Log("Font size: " + myMesh.fontSize + " And Character size: " + myMesh.characterSize);
            meshRenderer.sortingLayerName = "Poptext";
			new_text.transform.position = cam.transform.position - new Vector3(2.5f, 2.5f, cam.transform.position.z);

			//myTexture = UnityEditor.AssetDatabase.LoadAssetAtPath<Texture2D>("Assets/Images/oval.png");
			myTexture = Resources.Load<Texture2D>("Images/oval");
			Sprite mySprite = Sprite.Create(myTexture, new Rect(0, 0, 384, 192), new Vector2(), 64);
			new_sprite = new GameObject();
			new_sprite.AddComponent<SpriteRenderer>();
			SpriteRenderer ui_renderer = new_sprite.GetComponent<SpriteRenderer>();
			ui_renderer.sprite = mySprite;
            ui_renderer.sortingLayerName = "Popover";
			new_sprite.transform.position = cam.transform.position - new Vector3(3, 5.0f, cam.transform.position.z);

			
		}

		private void SetText(TextMesh mesh, MeshRenderer renderer, string text)
		{
			string builder = "";
			float rowLimit = 2.8f; //find the sweet spot    
			string[] parts = text.Split(' ');
			for (int i = 0; i < parts.Length; i++)
			{
				Debug.Log(parts[i]);
				mesh.text += parts[i] + " ";
				if (renderer.bounds.extents.x > rowLimit)
				{
					mesh.text = builder.TrimEnd() + System.Environment.NewLine + parts[i] + " ";
				}
				builder = mesh.text;
			}
			mesh.text = "";
			currentText = "";
			targetText = builder;
		}

		public bool Dismiss()
		{
			if (currentText == targetText)
			{
				UnityEngine.Object.Destroy(new_sprite);
				UnityEngine.Object.Destroy(new_text);
				return true;
			}
			else
			{
				currentText = targetText;
				TextMesh myMesh = new_text.GetComponent<TextMesh>();
				myMesh.text = currentText;
				return false;
			}
		}

		public void Continue()
		{
			drawNext = !drawNext;
			if (drawNext)
			{
				if (currentText != targetText)
				{
					currentText = targetText.Substring(0, currentText.Length + 1);
					TextMesh myMesh = new_text.GetComponent<TextMesh>();
					myMesh.text = currentText;
				}
			}
		}

		public bool drawNext;
		public string currentText = "";
		public string targetText = "";
		GameObject new_sprite;
		public Texture2D myTexture;
		GameObject new_text;
	}
}
